#include <dos.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

#define vbuf (char far *)0xA0000000
#define uchar unsigned char
#define uint unsigned int
#define WORD unsigned int
#define I asm


#define z_factor 1.0



WORD page1, page2; // segmenti degli schermi virtuali
WORD x_array[320], y_array[200];
char rand_tab[256];
uchar ir;

int getmemory(WORD *segment, WORD n_paragraphs)
{
// 1 paragrafo = 16 byte
WORD seg_adress;

asm{
    mov   ax, 4821h
    mov   bx, n_paragraphs
    int   21h
    mov   dx, ax // ax contiene l'indirizzo
    jnb   mem_ok
     mov   dx, 0a000h
     jmp   no_mem
}
 mem_ok:
asm{
      shl   bx, 3  // moltiplica per 8 il n di paragrafi
      mov   cx, bx // mette nel contatore "cx" il valore di "bx"
      mov   es, ax // segmento di partenza in "es"
      xor   di, di // azzera l'indice per "stosw"
      xor   ax, ax // valore per "stosw" (0)
      rep  stosw   // azzera l'area di memoria assegnata
}
 no_mem:

asm  mov  seg_adress, dx

 *segment = seg_adress;
  if(seg_adress==0xA000) return(0);
   else return(1);
}


void freememory(WORD segment)
{
asm{
    mov   ax, 4921h
    mov   bx, segment
    int   21h
   }
}







void copy_plasm(WORD offs, WORD source, WORD dest)
{
asm{
mov   di, offs
mov   si, 180*320 // source offset
mov   cx, 160

push  ds

 push  source
 pop   ds
 push  dest
 pop   es

 rep   movsw

pop   ds
}
}


void scale_up(WORD source, WORD dest)
{
asm{
mov   ax, OFFSET x_array
mov   bx, OFFSET y_array
xor   cx, cx
}
sy_loop:
I mov   si, OFFSET x_array
I mov   ax, 320
sx_loop:
 asm{
  mov   di, word ptr ds:[si] // x coord
  add   di, word ptr ds:[bx] // y coord

   push source; pop es
  mov   dl, byte ptr es:[di] // offset trasformato(legge)

  mov   di, cx

   push dest;   pop es
  mov   byte ptr es:[di], dl // scrive all'offset reale i dati letti

  inc   cx
  inc si
  inc si
  dec   ax
 jnz  sx_loop

 inc bx
 inc bx
 cmp   cx, 64000
jl sy_loop


}

}


void shade(WORD dest)
{
asm{
push  dest
pop   es
mov   di, 1
mov   cx, 64000-640

xor   bh, bh
}
shade_loop:
asm{

 mov    al, byte ptr es:[di+320]
 shl    ax, 2
 mov    bl, byte ptr es:[di]
 add    ax, bx
 mov    bl, byte ptr es:[di+1]
 add    ax, bx
 mov    bl, byte ptr es:[di-1]
 add    ax, bx
 mov    bl, byte ptr es:[di+640]
 add    ax, bx

 shr    ax, 3
  jz no_zero
 dec al
}
no_zero:
asm{
 mov byte ptr es:[di], al
 inc di
 loop shade_loop
}

}


void copy_screen(WORD source, WORD dest)
{
asm{

mov   dx, 3dah
}
retrace_loop:
asm{
in   al, dx
test   al, 8
jnz   retrace_loop

push  ds

push  source
pop   ds
push  dest
pop   es
xor   si, si
xor   di, di
mov   cx, 32000
rep   movsw

pop ds
}
}




void draw_line(int x1, int y1, int x2, int y2, WORD dest)
{
  int i, deltax, deltay, numpixels,
      d, dinc1, dinc2,
      x, xinc1, xinc2,
      y, yinc1, yinc2;

  uchar color;

  if (x1 < 0) x1 = 0; else if (x1 > 319) x1 = 319;
  if (x2 < 0) x2 = 0; else if (x2 > 319) x2 = 319;
  if (y1 < 0) y1 = 0; else if (y1 > 199) y1 = 199;
  if (y2 < 0) y2 = 0; else if (y2 > 199) y2 = 199;

  deltax = x2 - x1; if(deltax<0) deltax=-deltax;
  deltay = y2 - y1; if(deltay<0) deltay=-deltay;

  if (deltax >= deltay)
    {
      numpixels = deltax + 1;
      d = (deltay<<1) - deltax;
      dinc1 = deltay<<1;
      dinc2 = (deltay - deltax) << 1;
      xinc1 = 1;
      xinc2 = 1;
      yinc1 = 0;
      yinc2 = 1;
    }
  else
    {
      numpixels = deltay + 1;
      d = (deltax<<1) - deltay;
      dinc1 = deltax << 1;
      dinc2 = (deltax - deltay) << 1;
      xinc1 = 0;
      xinc2 = 1;
      yinc1 = 1;
      yinc2 = 1;
    }

  if (x1 > x2)
    {
      xinc1 = - xinc1;
      xinc2 = - xinc2;
    }
  if (y1 > y2)
    {
      yinc1 = - yinc1;
      yinc2 = - yinc2;
    }

  x = x1;
  y = y1;

  for (i=0; i < numpixels; i++)
    {
    color=rand_tab[ir++];
    asm{
	push  dest
	pop   es
	mov   di, x
	mov   si, y
	shl   si, 6
	add   di, si
	mov   si, y
	shl   si, 8
	add   di, si
	mov al, color
	mov byte ptr es:[di], al
       }
      //dest [x + (y<<6) + (y<<8)] = rand_tab[ir];

      if (d < 0)
	{
	  d = d + dinc1;
	  x = x + xinc1;
	  y = y + yinc1;
	}
      else
	{
	  d = d + dinc2;
	  x = x + xinc2;
	  y = y + yinc2;
	}
    }
}





void main(void)
{
uint yy, page_offset;
int ix, iy;
int px, py, pxx, pyy;
float ang=0.0;
uchar col;


if( (!getmemory(&page1, 4096)) || (!getmemory(&page2, 4096)))
{
 printf("impossibile allocare memoria per i buffer !\n\n");
 exit(1);
}

// MCGA 320x200 256
I mov ax, 13h
I int 10h

for(px=0; px<256; px++) rand_tab[px] = rand();
for(ix=0; ix<320; ix++) x_array[ix] = (ix - 160) / z_factor + 160;
for(iy=0; iy<200; iy++) y_array[iy] = ((iy - 100) / z_factor + 100)*320;

outp(968, 0);
// nero - rosso
for(yy=0; yy<64; yy++) { outp(969, yy); outp(969, 0); outp(969, 0); }
// rosso - giallo
for(yy=0; yy<32; yy++) { outp(969, 63); outp(969, yy*2); outp(969, 0); }
// giallo - bianco
for(yy=0; yy<32; yy++) { outp(969, 63); outp(969, 63); outp(969, yy*2); }
// bianco
for(yy=0; yy<255-128; yy++) { outp(969, 63); outp(969, 63); outp(969, 63); }
/*
// nero - viola
for(yy=0; yy<64; yy++) { outp(969, yy); outp(969, 0); outp(969, yy); }
// viola - blu
for(yy=0; yy<32; yy++) { outp(969, (31-yy)*2); outp(969, 0); outp(969, 63); }
// blu - bianco
for(yy=0; yy<32; yy++) { outp(969, yy*2); outp(969, yy*2); outp(969, 63); }
// bianco
for(yy=0; yy<255-128; yy++) { outp(969, 63); outp(969, 63); outp(969, 63); }
*/
/*
for(yy=0; yy<64; yy++) { outp(969, 0); outp(969, 0); outp(969, yy); }
for(yy=0; yy<64; yy++) { outp(969, yy); outp(969, yy); outp(969, 63); }
for(yy=0; yy<128; yy++) { outp(969, 63); outp(969, 63); outp(969, 63); }
*/
/*
outp(968, 1);
for(yy=1; yy<256; yy++, delay(4))
{
 outp(969, sin(M_PI/127.0*yy)*63);
 outp(969, sin(M_PI/128.0*yy*2)*31 + 32);
 outp(969, -sin(M_PI/128.0*yy)*31 + 32);
}
*/

page_offset = 0;
while(!kbhit())
{

I push page1
I pop  es
for(yy=1; yy<319; yy+=2)
{
_AL = rand();
I mov ah, al
I mov di, yy
I mov word ptr es:[di+198*320], ax
}


if(ang<M_PI*4.0-0.01) ang+=0.01; else ang=0.0;
px  = cos(ang)*75+165;
py  = sin(ang)*75+105;
pxx = sin(-ang*3)*75+160;
pyy = cos(-ang)*75+100;
 draw_line(px, py, pxx, pyy, page1);
 draw_line(319-px, 199-py, pxx, pyy, page1);
 draw_line(px, py, 319-pxx, 199-pyy, page1);
 draw_line(319-px, 199-py, 319-pxx, 199-pyy, page1);

shade(page1);
copy_screen(page1, 0xA000);

//copy_plasm(page_offset, page1, page2);
//page_offset+=320;


}

// becca un tasto
I xor   ax, ax
I int   16h
for(yy=0; yy<128; yy++)
{
shade(page1);
copy_screen(page1, 0xA000);
}


// modo testo
I mov ax, 3
I int 10h

// libera la memoria allocata
freememory(page1);
freememory(page2);

}
